<template>
  <div>
    <form @submit.prevent="handleSubmit" class="form">
      <p class="form__title">
        На этот адрес электронной почты будут отправляться уведомления о статусе
        заказа.
      </p>
      <div class="input__wrapper">
        <input
          type="email"
          v-model="email"
          placeholder="Электронная почта"
          @focus="handleFocus"
          @blur="handleBlur"
          class="form__input"
          @input="input"
          ref="input"
        />
        <p class="input__wrapper__text" v-if="required">email required</p>
      </div>

      <button type="submit" class="form__button" :disabled="loading">
        <span v-if="loading" class="loader"></span>
        <span v-else>Оформить заказ</span>
      </button>
    </form>
    <p v-if="successMessage" class="success-message">{{ successMessage }}</p>
  </div>
</template>

<script>
export default {
  data() {
    return {
      email: "",
      loading: false,
      successMessage: "",
      required: false,
    };
  },
  methods: {
    handleFocus(event) {
      event.target.classList.add("focused");
    },
    handleBlur(event) {
      event.target.classList.remove("focused");
    },
    async handleSubmit() {
      if (!this.email) {
        this.required = true;
        this.$refs.input.focus();
        return;
      }
      this.loading = true;
      await this.submitOrder();
      this.loading = false;
      this.successMessage = "Поздравляем с покупкой!";
      this.email = "";
      this.$emit("submit", { email: this.email });
    },
    input() {
      this.required = false;
    },
    submitOrder() {
      return new Promise((resolve) => {
        setTimeout(() => {
          resolve();
        }, 2000);
      });
    },
  },
};
</script>

<style scoped>
.form {
  display: flex;
  flex-direction: column;
  gap: 32px;
  max-width: 400px;
  margin: 0 auto;
}
.form__title {
  opacity: 0.6;
}
.form__input {
  height: 32px;
  width: 100%;
  border: none;
  border-bottom: 1px solid #ccc;
  box-sizing: border-box;
  transition: border-color 0.3s ease;
}
.form__input.focused {
  border-bottom: 1px solid blue;
  outline: none;
}
.form__button {
  height: 40px;
  border: none;
  background-color: blue;
  color: white;
  border-radius: 4px;
  cursor: pointer;
  font-size: 16px;
  position: relative;
  display: flex;
  align-items: center;
  justify-content: center;
}
.form__button:disabled {
  background-color: blue;
  cursor: not-allowed;
  display: flex;
  align-items: center;
  justify-content: center;
}
.form__button:hover:not(:disabled) {
  background-color: darkblue;
}
.loader {
  border: 2px solid blue;
  border-top: 2px solid rgb(255, 255, 255);
  border-left: 2px solid rgb(255, 255, 255);
  border-radius: 50%;
  width: 16px;
  height: 16px;
  animation: spin 1s linear infinite;

  transform: translate(-50%, -50%);
}
@keyframes spin {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}
.success-message {
  color: green;
  text-align: center;
  margin-top: 20px;
  font-size: 1.2em;
}
.input__wrapper {
  height: 60px;
}
.input__wrapper__text {
  margin: 6px;
  font-size: 12px;
  color: red;
  opacity: 0.8;
}
</style>
